package fr.eisti.ing1.java.teaching.data;
import org.example.teaching.data.Student;




public class EistiStudent extends Student implements Comparable<EistiStudent> {

	private static final long serialVersionUID = -550428455494581666L;

	private int ranking;
	public EistiStudent(String firstName, String lastName, int age, int ranking) {
		super(firstName, lastName, age);
		this.ranking = ranking;
	}
	
	public EistiStudent(Student t )
	{
		super(t.getFirstName(),t.getLastName(),t.getAge());
		this.ranking = 0;
	}

	public int getRanking() {
		return ranking;
	}

	public void setRanking(int ranking) {
		this.ranking = ranking;
	}


	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		EistiStudent other = (EistiStudent) obj;
		if (this.getFirstName() != other.getFirstName())
			return false;
		if (this.getLastName() != other.getLastName())
			return false;
		if (this.getAge() != other.getAge())
			return false;
		if (ranking != other.ranking)
			return false;
		return true;
	}

	public String toString()
	{
		return this.getFirstName()+" "+this.getLastName()+" ("+this.getAge()+") #"+this.getRanking() ;
	}


	public int compareTo(EistiStudent e) {
		if(this.getRanking()!= e.getRanking()){
			return Integer.valueOf(this.getRanking()).compareTo(e.getRanking());
		}
		if(this.getFirstName()!=e.getFirstName()){
			return this.getFirstName().compareTo(e.getFirstName());
		}
		if(this.getLastName()!=e.getLastName()){
			return this.getLastName().compareTo(e.getLastName());
		}
		else{
			return Integer.valueOf(this.getAge()).compareTo(e.getAge());
		}
	}

	
}
