package fr.eisti.ing1.java.teaching.data;

import java.io.*;

import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.example.teaching.data.Student;


public class Pool implements Iterable<EistiStudent>{

	private String name;
	private Vector<EistiStudent> vect = new Vector<EistiStudent>();
	
	public enum OrderType{NONE,ASCENDING,DESCENDING};

	
	public Pool(String name) {
		this.name = name;
		this.vect = new Vector<EistiStudent>();
	}

	public Pool(String name, String fichier) throws LoadStudentFileException
	{
		this.name = name;
		try{
			this.vect = loadStudentFile(fichier);
		}
		catch(LoadStudentFileException e)
		{
			e.getMessage();
			e.getStackTrace();
		}
	}

	private Vector<EistiStudent> loadStudentFile(String fichier) throws LoadStudentFileException {
		File f = new File(fichier);
		Vector<EistiStudent> v = new Vector<EistiStudent>();
    	try {
			FileInputStream fos = new FileInputStream(f);
			ObjectInputStream oos = new ObjectInputStream(fos);
			
				v.add(new EistiStudent((Student)oos.readObject()));
				v.add(new EistiStudent((Student)oos.readObject()));
				v.add(new EistiStudent((Student)oos.readObject()));
				v.add(new EistiStudent((Student)oos.readObject()));
				v.add(new EistiStudent((Student)oos.readObject()));
				v.add(new EistiStudent((Student)oos.readObject()));
				v.add(new EistiStudent((Student)oos.readObject()));
			
			oos.close();
			fos.close();
			return v;
		} catch (FileNotFoundException e) {
			throw new LoadStudentFileException();
		} catch (IOException e) {
			throw new LoadStudentFileException();
		} catch (ClassNotFoundException e) {
			throw new LoadStudentFileException();
		} 

	}

	public List<EistiStudent> trierEtudiant(OrderType order)
	{
		List<EistiStudent> l = Collections.list(Collections.enumeration(this.vect));
		
		if(order==OrderType.DESCENDING)
		{
			Collections.sort(l);
			Collections.reverse(l);
		}
		if(order==OrderType.ASCENDING)
		{
			
			Collections.sort(l);
		}
			
		return l;
	}
	

	public String getName() 
	{
		return name;
	}
	
	public int getTaille()
	{
		return this.vect.size();
	}

	private boolean existe(EistiStudent e)
	{
		return this.vect.contains(e);
	}
	
	public void ajouterEtudiant(EistiStudent e)
	{
		if(!existe(e))
		{
			this.vect.add(e);
		}
	}
	
	public void supprimerEtudiant(EistiStudent e)
	{
		this.vect.remove(e);
	}
	
	public Iterator<EistiStudent> iterator(OrderType order) {
		if(order==OrderType.DESCENDING)
		{
			List<EistiStudent> l = Collections.list(Collections.enumeration(this.vect));
			Collections.sort(l);
			Collections.reverse(l);
			return l.iterator();
		}
		if(order==OrderType.ASCENDING)
		{
			List<EistiStudent> l = Collections.list(Collections.enumeration(this.vect));
			Collections.sort(l);
			return l.iterator();
		}
		else
		{
			return this.iterator();
		}
	}

	public String toString()
	{
		return "Groupe : "+this.getName()+" ; Taille : "+this.getTaille();
	}

	public Vector<EistiStudent> getVect() {
		return this.vect;
	}

	@Override
	public Iterator<EistiStudent> iterator() {
		return this.vect.iterator();
	}




	
}



