package fr.eisti.ing1.java.teaching.manager;

import java.io.*;
import java.util.List;
import java.util.Scanner;
import java.util.Vector;

import fr.eisti.ing1.java.teaching.data.*;
import fr.eisti.ing1.java.teaching.data.Pool.OrderType;


public class MakePool implements Serializable{

	private static final long serialVersionUID = -8728751707184530330L;
	private Pool p;
	String nomGroupe;
	String nomFichierEntree;
	private String nomFichierSortie;
	
	public MakePool() throws LoadStudentFileException
	{
		Scanner sc = new Scanner(System.in);
		
		System.out.println("Veuillez saisir le nom du groupe :");
		nomGroupe = sc.nextLine();
		System.out.println();
		
		System.out.println("Veuillez saisir le nom du fichier d'entre : ");
		nomFichierEntree = sc.nextLine();
		System.out.println();
		
		System.out.println("Veuillez saisir le nom du fichier de sortie : ");
		nomFichierSortie = sc.nextLine();
		System.out.println();
		
	}
	
	private void construirePool() throws LoadStudentFileException
	{
		p = new Pool(nomGroupe,nomFichierEntree);
	}
	
	private void affecterRanking()
	{
		Vector<EistiStudent> v = (Vector<EistiStudent>) p.getVect();
		for(EistiStudent e : v )
		{
			e.setRanking((int)(Math.random()*20));
		}
	}
	
	private void afficher()
	{
		List<EistiStudent> l = p.trierEtudiant(OrderType.ASCENDING);
		System.out.println(p.toString());
		for(EistiStudent e : l)
		{
			System.out.println(e.toString());
		}
	}
	
	private void sauvegarder(){
		    
	    	File f = new File(nomFichierSortie);
	    	try {
				FileOutputStream fos = new FileOutputStream(f);
				ObjectOutputStream oos = new ObjectOutputStream(fos);
				List<EistiStudent> l = p.trierEtudiant(OrderType.ASCENDING);
				System.out.println(p.toString());
				for(EistiStudent e : l)
				{
					System.out.println(e.toString());
				}
				
				oos.writeChars(p.toString());
				for(EistiStudent e : l)
				{
					oos.writeChars(e.toString());
				}
				oos.close();
				fos.close();
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
	   	}

	public static void main(String[] args) throws LoadStudentFileException
	{
		MakePool mp = new MakePool();
		mp.construirePool();
		mp.affecterRanking();
		mp.afficher();
		mp.sauvegarder();
	}
}
